
// Reader.cpp : Defines the class behaviors for the application.
//--------------------------------------------------------------
#include "stdafx.h"
#include "Reader.h"
#include "ReaderDlg.h"
#include "MDBEngine.h"
#include "Device.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CReaderApp
//-----------
BEGIN_MESSAGE_MAP(CReaderApp, CWinApp)
	//{{AFX_MSG_MAP(CReaderApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

// CReaderApp construction
//------------------------

CReaderApp::CReaderApp()
//======================
{
	m_dwInstance=0;
}

// The one and only CReaderApp object
//-----------------------------------
CReaderApp theApp;

// CReaderApp initialization
//--------------------------

BOOL CReaderApp::InitInstance()
//=============================
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need.
	//----------------------------------------------------------------
#ifdef _AFXDLL
	Enable3dControls();	// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic(); // Call this when linking to MFC statically
#endif

	// Set the registry key under which our settings are stored.
	//----------------------------------------------------------
	SetRegistryKey(_T("BonusData"));

	// Parse command line
	//-------------------
	if (m_lpCmdLine[0]!='\0')
	{
		m_dwInstance=atoi(m_lpCmdLine);
		if (m_dwInstance>10)
			m_dwInstance=10;
	}

	// Download target firmware
	//-------------------------
	CString sSection;
	sSection.Format(_T("Current%02u"),m_dwInstance);
	DWORD dwDevice=GetProfileInt(sSection,_T("Device"),0)+256;
	if (!DownloadTarget(0,25))
	{
		AfxMessageBox(_T("Failed to initialize MDB interface!\r\n")
			_T("Probably the interface is not connected."),
			MB_OK|MB_ICONSTOP);
		CDevice Device;
		Device.DoModal();
		return false;
	}

	// Show main dialog
	//-----------------
	CReaderDlg ReaderDlg;
	m_pMainWnd=&ReaderDlg;
	ReaderDlg.DoModal();
	return FALSE;
}
