
// ReaderDlg.cpp : implementation file
//------------------------------------
#include "stdafx.h"
#include "Reader.h"
#include "ReaderDlg.h"
#include "MDBEngine.h"
#include "ReaderInfo.h"
#include "PriceDlg.h"
#include "Device.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CReaderDlg dialog
//------------------

CReaderDlg::CReaderDlg(CWnd* pParent) : CDialog(CReaderDlg::IDD, pParent)
//=======================================================================
{
	//{{AFX_DATA_INIT(CReaderDlg)
	m_dwRevalueAmount = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dwRevalueLimit=0;
}

void CReaderDlg::DoDataExchange(CDataExchange* pDX)
//=================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReaderDlg)
	DDX_Control(pDX, IDC_DISPLAY, m_Display);
	DDX_Text(pDX, IDC_REVALUE_AMOUNT, m_dwRevalueAmount);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReaderDlg, CDialog)
	//{{AFX_MSG_MAP(CReaderDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_BN_CLICKED(IDC_DISABLE, OnDisable)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_COMMAND(IDM_READER_INFO, OnReaderInfo)
	ON_BN_CLICKED(IDC_SELECTION_1, OnSelection1)
	ON_BN_CLICKED(IDC_SELECTION_2, OnSelection2)
	ON_BN_CLICKED(IDC_SELECTION_3, OnSelection3)
	ON_BN_CLICKED(IDC_SELECTION_4, OnSelection4)
	ON_COMMAND(IDM_PRICE_SETUP, OnPriceSetup)
	ON_BN_CLICKED(IDC_COMPLETE, OnComplete)
	ON_BN_CLICKED(IDC_REVALUE, OnRevalue)
	ON_BN_CLICKED(IDC_VEND_CANCEL, OnVendCancel)
	ON_BN_CLICKED(IDC_VEND_FAILURE, OnVendFailure)
	ON_BN_CLICKED(IDC_VEND_SUCCESS, OnVendSuccess)
	ON_COMMAND(IDM_SETDEVICE, OnSetdevice)
	ON_EN_KILLFOCUS(IDC_REVALUE_AMOUNT, OnKillfocusRevalueAmount)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_READER_STATUS, OnStatusChange)
END_MESSAGE_MAP()

// CReaderDlg message handlers
//----------------------------

BOOL CReaderDlg::OnInitDialog()
//=============================
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog. The framework does this automatically
	// when the application's main window is not a dialog
	//--------------------------------------------------------------------
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE); // Set small icon
	
	// Initialize MDB master
	//----------------------
	m_Display.SetWindowText(_T("Initialize..."));
	CReaderApp* pApp=(CReaderApp*)AfxGetApp();
	CString sSection;
	sSection.Format(_T("Current%02u"),pApp->m_dwInstance);
	SLAVE_SETUP Setup;
	memset(&Setup,0,sizeof(SLAVE_SETUP));
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
	Setup.dwTimeout=5;
//	Setup.dwDevice=AfxGetApp()->GetProfileInt(sSection,_T("Device"),0)+256;
	Setup.dwDevice=0;
	if (!ReaderCreate(&Setup))
	{
		TRACE(_T("Failed to create reader\r\n"));
	}
	return true;
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CReaderDlg::OnPaint() 
//========================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND,(WPARAM)dc.GetSafeHdc(),0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
//------------------------------------------------------

HCURSOR CReaderDlg::OnQueryDragIcon()
//===================================
{
	return (HCURSOR)m_hIcon;
}

void CReaderDlg::OnAboutbox() 
//===========================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

void CReaderDlg::OnDestroy() 
//==========================	
{
	if (!ReaderDestroy())
	{
		TRACE(_T("Failed to destroy reader\r\n"));
	}
	CDialog::OnDestroy();
}

void CReaderDlg::OnEnable() 
//=========================
{
	ReaderEnable(true);
}

void CReaderDlg::OnDisable() 
//==========================
{
	ReaderEnable(false);	
}

void CReaderDlg::OnReset() 
//========================
{
	ReaderReset();	
}

void CReaderDlg::OnReaderInfo() 
//=============================
{
	CReaderInfo ReaderInfo;
	ReaderInfo.DoModal();
}

void CReaderDlg::OnStatusChange(WPARAM wParam, LPARAM lParam)
//===========================================================
{
	switch (wParam)
	{
		case SS_READER_READY:
		case SS_READER_END_SESSION:
		{
			m_Display.SetWindowText(_T("Reader Ready."));
			break;
		}
		case SS_READER_ENABLE:
		{
			m_Display.SetWindowText(_T("Reader Enabled."));
			break;
		}
		case SS_READER_DISABLE:
		{
			m_Display.SetWindowText(_T("Reader Disabled."));
			break;
		}
		case SS_READER_BEGIN_SESSION:
		case SS_READER_APPROVED:
		case SS_READER_REVALUE_APPROVED:
		{
			CString sTemporary;
			READER_SESSION Session;
			ReaderSession(&Session);
			sTemporary.Format(_T("Funds: %u"),Session.dwFunds);
			m_Display.SetWindowText(sTemporary);
			break;
		}
	}
}

void CReaderDlg::OnSelection1() 
//=============================
{
	READER_REQUEST Request;
	Request.dwItemPrice=AfxGetApp()->GetProfileInt(_T("Settings"),_T("Price1"),10);
	Request.dwItemNumber=1;
	ReaderVendRequest(&Request);
}

void CReaderDlg::OnSelection2() 
//=============================
{
	READER_REQUEST Request;
	Request.dwItemPrice=AfxGetApp()->GetProfileInt(_T("Settings"),_T("Price2"),20);
	Request.dwItemNumber=2;
	ReaderVendRequest(&Request);
}

void CReaderDlg::OnSelection3()
//============================= 
{
	READER_REQUEST Request;
	Request.dwItemPrice=AfxGetApp()->GetProfileInt(_T("Settings"),_T("Price3"),30);
	Request.dwItemNumber=3;
	ReaderVendRequest(&Request);
}

void CReaderDlg::OnSelection4()
//============================= 
{
	READER_REQUEST Request;
	Request.dwItemPrice=AfxGetApp()->GetProfileInt(_T("Settings"),_T("Price4"),40);
	Request.dwItemNumber=4;
	ReaderVendRequest(&Request);
}

void CReaderDlg::OnPriceSetup() 
//=============================
{
	CPriceDlg PriceDlg;
	PriceDlg.DoModal();
}

void CReaderDlg::OnVendCancel() 
//=============================
{
	ReaderVendStatus(READER_VEND_CANCEL);
}

void CReaderDlg::OnVendSuccess() 
//==============================
{
	ReaderVendStatus(READER_VEND_SUCCESS);
}

void CReaderDlg::OnVendFailure() 
//==============================
{
	ReaderVendStatus(READER_VEND_FAILURE);
}

void CReaderDlg::OnComplete() 
//===========================
{
	ReaderSessionComplete();	
}

void CReaderDlg::OnRevalue() 
//==========================
// The revalue limit request needs some time:
// - Request the new limit and then wait for it
//   by polling until it returns true.
//---------------------------------------------
{
	DWORD dwRetry=10;
	ReaderRevalueLimit(&m_dwRevalueLimit,true);
	while (!ReaderRevalueLimit(&m_dwRevalueLimit))
	{
		dwRetry--;
		if (dwRetry==0)
		{
			return;
		}
		Sleep(100);
	}
	if (m_dwRevalueAmount>m_dwRevalueLimit)
	{
		m_dwRevalueAmount=m_dwRevalueLimit;
		UpdateData(false);
	}
	ReaderRevalueRequest(m_dwRevalueAmount);	
}

void CReaderDlg::OnSetdevice()
//============================
{
	CDevice Device;
	Device.DoModal();
}

void CReaderDlg::OnKillfocusRevalueAmount() 
//=========================================
{
	UpdateData();	
}
